
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>psql: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">avito-microservice/internal/repository/psql/repo_psql.go (96.7%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package psql

import (
        "database/sql"
)

type WalletPsqlRepository struct {
        DB *sql.DB
}

func NewWalletPsqlRepository(db *sql.DB) *WalletPsqlRepository <span class="cov8" title="1">{
        return &amp;WalletPsqlRepository{DB: db}
}</span>


func (wr *WalletPsqlRepository) GetBalance(userID int) (float64, error) <span class="cov8" title="1">{
        var userBalance float64

        err := wr.DB.QueryRow(
                "SELECT balance FROM wallet WHERE user_id=$1",
                userID).
                Scan(&amp;userBalance)

        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return userBalance, nil</span>
}

func (wr *WalletPsqlRepository) CheckUserExistence(userID int) (bool, error) <span class="cov8" title="1">{
        var result bool
        err := wr.DB.QueryRow("select exists(select 1 from wallet where user_id=$1)", userID).Scan(&amp;result)
        return result, err
}</span>

func (wr *WalletPsqlRepository) CreateUserWallet(userID int) error <span class="cov8" title="1">{
        _, err := wr.DB.Exec("INSERT INTO wallet (user_id, balance) VALUES ($1, 0)", userID)
        if err != nil </span><span class="cov8" title="1">{
                return err
        }</span>

        <span class="cov8" title="1">return nil</span>
}

func (wr *WalletPsqlRepository) UpdateBalance(userID int, amount float64) error <span class="cov8" title="1">{
        _, err := wr.DB.Exec(
                "UPDATE wallet SET balance = balance + $1 WHERE user_id=$2", amount, userID)
        if err != nil </span><span class="cov8" title="1">{
                return err
        }</span>

        <span class="cov8" title="1">return nil</span>
}

func (wr *WalletPsqlRepository) TransferFunds(fromUserID, toUserID int, amount float64) error <span class="cov8" title="1">{
        // Start transaction
        tx, err := wr.DB.Begin()
        if err != nil </span><span class="cov0" title="0">{
                return err
        }</span>

        <span class="cov8" title="1">_, err = tx.Exec("UPDATE wallet SET balance = balance - $1 WHERE user_id=$2", amount, fromUserID)
        if err != nil </span><span class="cov8" title="1">{
                tx.Rollback()
                return err
        }</span>

        <span class="cov8" title="1">_, err = tx.Exec(
                  "UPDATE wallet SET balance = balance + $1 WHERE user_id=$2",
                amount, toUserID)
        if err != nil </span><span class="cov8" title="1">{
                tx.Rollback()
                return err
        }</span>

        // End of transaction
        <span class="cov8" title="1">err = tx.Commit()
        return err</span>
}</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
